#define _SUPPRESS_PLIB_WARNING
#include <plib.h>
#include "cfunctions.h"
long long autorun(void){
return Option->Autorun;
}
long long npins(void){//Cfunction
    return NBRPINS;
}
long long floatconv(float *a){
        union ftype{
            unsigned long a;
            float b;
        }f;
        f.b=*a;
        return f.a;
}
long long floattestmulby2(float *val){
    unsigned long a=0x40000000; //2.0
        *val=FMul(*val,LoadFloat(a));
        return 0;
}
long long clockon(long long *div){
  if(HAS_28PINS)ExtCfg(15,EXT_DIG_OUT,0);else ExtCfg(42,EXT_DIG_OUT,0);
  PPSOutput(3, RPB6, REFCLKO);
  REFOCONbits.ON = 0;     // Reference Oscillator Module
  REFOCONbits.ROSEL = 7; // Reference Clock Source Select
  REFOCONbits.RODIV = *div; // Reference Clock Source Select
  REFOCONbits.ON = 1;     // Reference Oscillator Module
  REFOCONbits.OE = 1;     // Reference clock is driven out
}
long long clockoff(long long *div){//Cfunction
  PPSOutput(3, RPB6, NULL);
  REFOCONbits.ON = 0;     // Reference Oscillator Module
   if(HAS_28PINS)ExtCfg(15,EXT_NOT_CONFIG,0);else ExtCfg(42,EXT_NOT_CONFIG,0);
}

long long readinternaltemp(long long *frig){
    int anChan,i;
    long val=0;
    CTMUCON = 0b00000010000000001000000000000001;
    CloseADC10();
    for(i=0;i<=8;i++){
        anChan = ADC_CH0_POS_SAMPLEA_AN13;
        SetChanADC10( ADC_CH0_NEG_SAMPLEA_NVREF | anChan );
        OpenADC10( ADC_FORMAT_INTG | ADC_CLK_AUTO | ADC_AUTO_SAMPLING_ON , \
                   ADC_VREF_EXT_AVSS | ADC_OFFSET_CAL_DISABLE | ADC_SCAN_OFF | ADC_SAMPLES_PER_INT_1| ADC_ALT_BUF_ON | ADC_ALT_INPUT_ON , \
                   ADC_CONV_CLK_INTERNAL_RC | ADC_SAMPLE_TIME_15 , \
                   0 /* anInput */ , \
                   SKIP_SCAN_ALL \
                 );
        EnableADC10();                                              // Enable the ADC
        while ( ! mAD1GetIntFlag()) ;
        val+= ReadADC10(0);                                         // read the result of the conversion
        if(i==0)val=0; //scrap the first reading
        mAD1ClearIntFlag();
        uSec(1000);
    }
    CloseADC10();                                               // turn off the ADC so that it does not add to the power drain (particularly in sleep)
    CTMUCON = 0b0;
    if(frig==NULL) {
       return (1416-val)/8+28;}
    else{
       return (1416-val)/8+28+*frig;
    }
}

long long readref(float *a){
    int anChan,i;
    long val=0;
    CM1CON = 0b1000000000010011; uSec(1000);       // turn on the internal voltage reference and let it settle
    CloseADC10();
    for(i=0;i<=8;i++){
        anChan = ADC_CH0_POS_SAMPLEA_AN13;
        SetChanADC10( ADC_CH0_NEG_SAMPLEA_NVREF | anChan );
        OpenADC10( ADC_FORMAT_INTG | ADC_CLK_AUTO | ADC_AUTO_SAMPLING_ON , \
                   ADC_VREF_AVDD_AVSS | ADC_OFFSET_CAL_DISABLE | ADC_SCAN_OFF | ADC_SAMPLES_PER_INT_1| ADC_ALT_BUF_ON | ADC_ALT_INPUT_ON , \
                   ADC_CONV_CLK_INTERNAL_RC | ADC_SAMPLE_TIME_15 , \
                   0 /* anInput */ , \
                   SKIP_SCAN_ALL \
                 );
        EnableADC10();                                              // Enable the ADC
        while ( ! mAD1GetIntFlag()) ;
        val+= ReadADC10(0);                                         // read the result of the conversion
        if(i==0)val=0; //scrap the first reading
        mAD1ClearIntFlag();
        uSec(1000);
    }
    CloseADC10();                                               // turn off the ADC so that it does not add to the power drain (particularly in sleep)
    CM1CON = 0;                                                 // turn off the internal voltage reference (in case pin = 0)
    *a=FDiv(LoadFloat(0x453A2E8C),IntToFloat(val)); //0x453A2E8C = 1.2 * 8192 / 3.3
   return val>>3;
}

long long stringsort(unsigned char *sarray, long long *nstring, long long *maxlength){
long ii,offset=*maxlength+1,i, s = 1, n=*nstring;
long k;
unsigned char *s1,*s2,*p1,*p2;
unsigned char temp;
    while (s){
      s=0;
      for(i=1;i<n;i++){
        s2=i*offset+sarray;
        s1=(i-1)*offset+sarray;
        ii = *s1 < *s2 ? *s1 : *s2; //get the smaller  length
        p1 = s1 + 1; p2 = s2 + 1;
        k=0; //assume the strings match
        while((ii--) && (k==0)) {
          if(*p1 > *p2){
            k=1; //earlier in the array is bigger
          }
          if(*p1 < *p2){
             k=-1; //later in the array is bigger
          }
          p1++; p2++;
        }
      // if up to this point the strings match
      // make the decision based on which one is shorter
      if(k==0){
        if(*s1 > *s2) k=1;
        if(*s1 < *s2) k=-1;
      }
      if (k==1){ // if earlier is bigger swap them round
        ii = *s1 > *s2 ? *s1 : *s2; //get the bigger length
        ii++;
        p1=s1;p2=s2;
        while(ii--){
          temp=*p1;
          *p1=*p2;
          *p2=temp;
          p1++; p2++;
        }
        s=1;
      }
    }
  }
return k;
}
long long combsort(long long a[], long long *nn){
  long l, j, gap, swapped = 1,nElements=*nn;
  long long temp;

  gap = nElements;
  while (gap > 1 || swapped == 1)
  {
    gap = gap * 10 / 13;
    if (gap == 9 || gap == 10) gap = 11;
    if (gap < 1) gap = 1;
    swapped = 0;
    for (l = 0, j = gap; j < nElements; l++, j++)
    {
      if (a[l] > a[j])
      {
        temp = a[l];
        a[l] = a[j];
        a[j] = temp;
        swapped = 1;
      }
    }
  }
}
long long shellsort(long long a[], long long *nn) {
    long h, l, j, n=*nn;
    long long k;
    for (h = n; h /= 2;) {
        for (l = h; l < n; l++) {
            k = a[l];
            for (j = l; j >= h && k < a[j - h]; j -= h) {
                a[j] = a[j - h];
            }
            a[j] = k;
        }
    }
    return 0;
}

void main(){}

